package middleware

import (
	"mtp20access/model/common/response"
	"mtp20access/utils"

	"github.com/gin-gonic/gin"
)

// FIXME - Token校验机制不适用，应重新设计
func JWTAuth() gin.HandlerFunc {
	return func(c *gin.Context) {
		// 我们这里jwt鉴权取头部信息 x-token 登录时回返回token信息 这里前端需要把token存储到cookie或者本地localStorage中 不过需要跟后端协商过期时间 可以约定刷新令牌或者重新登录
		token := c.Request.Header.Get("x-token")
		if token == "" {
			response.FailWithDetailed(gin.H{"reload": true}, "未登录或非法访问", c)
			c.Abort()
			return
		}

		j := utils.NewJWT()
		// parseToken 解析token包含的信息
		claims, err := j.ParseToken(token)
		if err != nil {
			if err == utils.ErrTokenExpired {
				response.FailWithCodeAndDetail(gin.H{"reload": true}, response.ERROR_TOKEN_EXPIRED, "授权已过期", c)
				c.Abort()
				return
			}
			response.FailWithDetailed(gin.H{"reload": true}, err.Error(), c)
			c.Abort()
			return
		}
		// 从Redis获取登录信息
		loginMap, err := j.GetRedisLogin(claims.LoginID, claims.Group)
		if err != nil {
			response.FailWithCodeAndDetail(gin.H{"reload": true}, response.ERROR_TOKEN_OTHER_LOGIN, "您的帐户异地登陆或令牌失效", c)
			c.Abort()
			return
		}
		// 判断Token是否有效
		if redisToken, isHas := loginMap["token"]; isHas {
			if redisToken != token {
				response.FailWithCodeAndDetail(gin.H{"reload": true}, response.ERROR_TOKEN_OTHER_LOGIN, "您的帐户异地登陆或令牌失效", c)
				c.Abort()
				return
			}
		} else {
			response.FailWithDetailed(gin.H{"reload": true}, "未登录或非法访问", c)
			c.Abort()
			return
		}

		// 判断是否需要自动续约
		// if claims.ExpiresAt.Unix()-time.Now().Unix() < claims.BufferTime {
		// 	claims.ExpiresAt = jwt.NewNumericDate(time.Now().Add(time.Duration(global.M2A_CONFIG.JWT.ExpiresTime)))
		// 	newToken, _ := j.CreateTokenByOldToken(token, *claims)
		// 	newClaims, _ := j.ParseToken(newToken)
		// 	c.Header("new-token", newToken)
		// 	c.Header("new-expires-at", strconv.FormatInt(newClaims.ExpiresAt.Unix(), 10))

		// 	// RedisJwtToken, err := j.GetRedisJWT(newClaims.LoginID)
		// 	if err != nil {
		// 		global.M2A_LOG.Error("get redis jwt failed", zap.Error(err))
		// 	} else { // 当之前的取成功时才进行拉黑操作
		// 		_ = j.JsonInBlacklist(RedisJwtToken)
		// 	}
		// 	// 无论如何都要记录当前的活跃状态
		// 	_ = j.SetRedisJWT(newToken, newClaims.LoginID)
		// }
		c.Set("claims", claims)
		c.Next()
	}
}
